import {
  ListboxKbNavController,
  unwrap
} from "./chunk.MIY5GV6X.js";
import {
  TransitionalStyles
} from "./chunk.TQCUATGL.js";
import {
  watch
} from "./chunk.TYGMNHNO.js";
import {
  GdsElement
} from "./chunk.WIZDAKJ5.js";
import {
  gdsCustomElement,
  html
} from "./chunk.MLXMQIEV.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet
} from "./chunk.SEHSDSX2.js";

// libs/core/src/primitives/listbox/listbox.ts
import { property } from "lit/decorators.js";
import { createRef, ref } from "lit/directives/ref.js";

// libs/core/src/primitives/listbox/listbox.styles.ts
import { css } from "lit";
var style = css`
  @layer base, reset, transitional-styles;
  @layer base {
    :host {
      display: flex;
      flex-direction: column;
      overflow: auto;
    }
  }
`;
var listbox_styles_default = style;

// libs/core/src/primitives/listbox/listbox.ts
var _slotRef, _handleSelect;
var GdsListbox = class extends GdsElement {
  constructor() {
    super();
    this.multiple = false;
    this.compareWith = (a, b) => a === b;
    __privateAdd(this, _slotRef, createRef());
    __privateAdd(this, _handleSelect, (e) => {
      const option = e.target;
      if (this.multiple)
        option.selected = !option.selected;
      else {
        option.selected = true;
        Array.from(this.options).forEach((el) => {
          if (el !== option)
            el.selected = false;
        });
      }
      ;
      this.ariaActiveDescendantElement = option;
      this.dispatchEvent(
        new CustomEvent("change", {
          bubbles: false,
          composed: false
        })
      );
    });
    new ListboxKbNavController(this);
  }
  get navigableItems() {
    return this.visibleOptionElements;
  }
  /**
   * Returns a list of all `gds-option` elements in the listbox.
   */
  get options() {
    if (!__privateGet(this, _slotRef).value)
      return [];
    return unwrap(__privateGet(this, _slotRef).value).assignedElements().filter(
      (o) => !o.hasAttribute("isplaceholder") && o.gdsElementName === "gds-option"
    ) || [];
  }
  /**
   * Returns a list of all visible `gds-option` elements in the listbox.
   */
  get visibleOptionElements() {
    return this.options.filter((el) => !el.hidden);
  }
  /**
   * Returns a list of all visible `gds-option` elements in the listbox.
   */
  get visibleSelectedOptionElements() {
    return this.options.filter((el) => el.selected && !el.hidden);
  }
  /**
   * Returns a list of all selected `gds-option` elements in the listbox.
   */
  get selection() {
    return this.options.filter((el) => el.selected);
  }
  set selection(values) {
    this.options.forEach((el) => {
      el.selected = values.some((v) => this.compareWith(v, el.value));
    });
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "listbox");
    TransitionalStyles.instance.apply(this, "gds-listbox");
    this.addEventListener("gds-select", __privateGet(this, _handleSelect));
  }
  /**
   * Focuses the first selected option in the listbox.
   * If no option is selected, the first visible option is focused.
   */
  focus() {
    var _a;
    ;
    (_a = this.visibleSelectedOptionElements[0] || this.visibleOptionElements[0]) == null ? void 0 : _a.focus();
  }
  render() {
    return html`<slot ${ref(__privateGet(this, _slotRef))}></slot>`;
  }
  _rerenderOptions() {
    this.options.forEach((el) => {
      el.requestUpdate();
    });
  }
};
_slotRef = new WeakMap();
_handleSelect = new WeakMap();
GdsListbox.styles = listbox_styles_default;
__decorateClass([
  property({
    type: Boolean,
    reflect: true,
    attribute: "aria-multiselectable",
    converter: {
      fromAttribute: Boolean,
      toAttribute: (value) => value.toString()
    }
  })
], GdsListbox.prototype, "multiple", 2);
__decorateClass([
  property()
], GdsListbox.prototype, "compareWith", 2);
__decorateClass([
  watch("multiple")
], GdsListbox.prototype, "_rerenderOptions", 1);
GdsListbox = __decorateClass([
  gdsCustomElement("gds-listbox")
], GdsListbox);

export {
  GdsListbox
};
