import {
  styleExpressionProperty
} from "./chunk.6UWYSL2J.js";
import {
  forwardAttributes
} from "./chunk.MBK24M3D.js";
import {
  GdsFormControlElement
} from "./chunk.X7GD7UEM.js";
import {
  watch
} from "./chunk.TYGMNHNO.js";
import {
  tokens
} from "./chunk.G4YDI5AG.js";
import {
  gdsCustomElement,
  html
} from "./chunk.MLXMQIEV.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet,
  __privateMethod
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/textarea/textarea.ts
import { property, query, queryAsync, state } from "lit/decorators.js";
import { until } from "lit/directives/until.js";
import { nothing } from "lit/html.js";
import { when } from "lit/directives/when.js";
import { choose } from "lit/directives/choose.js";
import { msg } from "@lit/localize";

// libs/core/src/components/textarea/textarea.styles.ts
import { css } from "lit";
var styles = css`
  @layer tokens, a11y, base, simplified;

  @layer tokens {
    :host {
      --_transition: all 368ms cubic-bezier(0.4, 0, 0.2, 1), height 0s;
    }
  }

  @layer a11y {
    @media (prefers-reduced-motion: reduce) {
      :host {
        --_transition: none;
      }
    }

    @media (prefers-reduced-transparency: reduce) {
      :host {
        --_transparency: 1;
      }
    }
  }

  @layer base {
    * {
      box-sizing: border-box;
    }

    :host {
      width: 100%;
      contain: layout;
      isolation: isolate;
    }

    :host([size='small']) textarea {
      font-size: var(--gds-text-size-detail-s);
      line-height: var(--gds-text-line-height-detail-s);
    }

    .field {
      transition: var(--_transition);
      position: relative;
      outline: 2px solid transparent;
      outline-offset: 2px;

      &:has(textarea:focus-visible) {
        border-color: var(--gds-color-l3-border-primary);
        outline-color: currentColor;
      }

      &.invalid:has(textarea:focus-visible) {
        border-color: var(--gds-color-l3-border-negative);
      }
    }

    @media (hover: hover) {
      .field {
        &:hover {
          background: color-mix(
            in srgb,
            var(--gds-color-l3-background-secondary),
            var(--gds-color-l3-states-light-hover)
          );
        }

        &.invalid:hover {
          background: color-mix(
            in srgb,
            var(--gds-color-l3-background-negative-secondary),
            var(--gds-color-l3-states-negative-hover)
          );
        }
      }
    }

    textarea {
      appearance: none;
      background-color: transparent;
      border: 0;
      box-sizing: border-box;
      font-family: inherit;
      font-size: var(--gds-text-size-detail-m);
      height: calc(1lh * var(--_lines));
      line-height: var(--gds-text-line-height-detail-m);
      margin: unset;
      min-height: calc(1lh * 4);
      outline: none;
      overflow: hidden;
      padding: unset;
      resize: none;
      transition:
        var(--_transition),
        resize 0s;

      width: 100%;
    }

    :host([size='small']) slot[name='lead']::slotted(*) {
      width: var(--gds-space-m);
    }

    slot[name='lead']::slotted(*) {
      min-width: var(--gds-space-l);
      display: flex;
    }

    .extended-supporting-text {
      opacity: 1;
      translate: 0;
      transition: var(--_transition);

      @starting-style {
        opacity: 0;
        translate: 0 2px;
      }
    }

    .resize-handle {
      &:hover,
      &:active {
        &::before {
          width: 22px;
          opacity: 1;
          height: 1px;
        }
      }
      &::before {
        content: '';
        position: absolute;
        background: currentColor;
        inset: 0;
        margin-inline: auto;
        height: 0px;
        width: 12px;
        opacity: 0;
        border-radius: 100px;
        transition: var(--_transition);
      }
    }
  }

  @layer simplified {
    // ...
  }
`;

// libs/core/src/components/textarea/textarea.ts
var _renderDefault, renderDefault_fn, _renderFloatingLabel, renderFloatingLabel_fn, _forwardableAttrs, _handleOnInput, _handleOnChange, _handleFieldClick, _handleClearBtnClick, _handleSupportingTextBtnClick, _renderSlotLead, renderSlotLead_fn, _renderSlotTrail, renderSlotTrail_fn, _addResizeHandleListener, addResizeHandleListener_fn, _startDragging, startDragging_fn, _onDrag, onDrag_fn, _stopDragging, stopDragging_fn, _renderResizeHandle, renderResizeHandle_fn, _handleSlotChange, handleSlotChange_fn, _renderNativeTextarea, renderNativeTextarea_fn, _renderSupportingText, renderSupportingText_fn, _renderExtendedSupportingText, renderExtendedSupportingText_fn, _renderClearButton, renderClearButton_fn, _shouldShowRemainingChars, shouldShowRemainingChars_get, _renderRemainingCharsBadge, renderRemainingCharsBadge_fn, _asyncRenderExtendedSupportingTextButton, asyncRenderExtendedSupportingTextButton_fn;
var GdsTextarea = class extends GdsFormControlElement {
  constructor() {
    super();
    __privateAdd(this, _renderDefault);
    // variant="floatingLabel"
    __privateAdd(this, _renderFloatingLabel);
    __privateAdd(this, _renderSlotLead);
    __privateAdd(this, _renderSlotTrail);
    __privateAdd(this, _addResizeHandleListener);
    __privateAdd(this, _startDragging);
    __privateAdd(this, _onDrag);
    __privateAdd(this, _stopDragging);
    __privateAdd(this, _renderResizeHandle);
    __privateAdd(this, _handleSlotChange);
    __privateAdd(this, _renderNativeTextarea);
    __privateAdd(this, _renderSupportingText);
    __privateAdd(this, _renderExtendedSupportingText);
    __privateAdd(this, _renderClearButton);
    __privateAdd(this, _shouldShowRemainingChars);
    __privateAdd(this, _renderRemainingCharsBadge);
    /**
     * Returns a promise that resolves when the DOM query for the extended supporting text slot has resolved.
     * If the slot is empty, an empty template is returned, otherwise the support text toggle button is returned.
     */
    __privateAdd(this, _asyncRenderExtendedSupportingTextButton);
    this.value = "";
    this.label = "";
    this.rows = 4;
    this.lines = 4;
    // Default number of lines
    this.isDragging = false;
    // Track dragging state
    this.lastMouseY = 0;
    this.supportingText = "";
    this.showExtendedSupportingText = false;
    this.disabled = false;
    this.clearable = false;
    this.resize = "";
    this.maxlength = Number.MAX_SAFE_INTEGER;
    this.variant = "default";
    this.trailSlotOccupied = false;
    // Any attribute name added here will get forwarded to the native <input> element.
    __privateAdd(this, _forwardableAttrs, (attr) => ["type", "placeholder", "required"].includes(attr.name));
    __privateAdd(this, _handleOnInput, (e) => {
      const element = e.target;
      this.value = element.value;
    });
    __privateAdd(this, _handleOnChange, (e) => {
      const element = e.target;
      this.value = element.value;
      this.dispatchEvent(
        new Event("change", {
          bubbles: true,
          composed: true
        })
      );
    });
    __privateAdd(this, _handleFieldClick, () => {
      this.elTextareaAsync.then((el) => el.focus());
    });
    __privateAdd(this, _handleClearBtnClick, () => {
      this.value = "";
    });
    __privateAdd(this, _handleSupportingTextBtnClick, () => {
      this.showExtendedSupportingText = !this.showExtendedSupportingText;
      this.dispatchEvent(
        new CustomEvent("gds-ui-state", {
          bubbles: true,
          composed: true,
          detail: this.showExtendedSupportingText
        })
      );
    });
    this.lines = 0;
    this.resize = "auto";
  }
  connectedCallback() {
    super.connectedCallback();
    this._setAutoHeight();
    __privateMethod(this, _addResizeHandleListener, addResizeHandleListener_fn).call(this);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    __privateMethod(this, _addResizeHandleListener, addResizeHandleListener_fn).call(this);
  }
  render() {
    return html`${choose(this.variant, [
      ["default", () => __privateMethod(this, _renderDefault, renderDefault_fn).call(this)],
      ["floating-label", () => __privateMethod(this, _renderFloatingLabel, renderFloatingLabel_fn).call(this)]
    ])}`;
  }
  _getValidityAnchor() {
    return this.elTextarea;
  }
  _setAutoHeight() {
    this.elTextareaAsync.then((element) => {
      const lines = (element.value.split("\n").length || 1).toString();
      element == null ? void 0 : element.style.setProperty("--_lines", lines.toString());
    });
  }
};
_renderDefault = new WeakSet();
renderDefault_fn = function() {
  return html`
      <gds-flex
        flex-direction="column"
        width="100%"
        gap="xs"
        level="3"
        user-select="${this.disabled ? "none" : "auto"}"
        pointer-events="${this.disabled ? "none" : "auto"}"
        color="${this.disabled ? "disabled" : this.invalid ? "negative" : "tertiary"}"
      >
        <gds-flex
          class="head"
          align-items="center"
          justify-content="space-between"
          padding="3xs 0 0 0"
        >
          <gds-flex flex-direction="column">
            <gds-text font-weight="book" font-size="detail-m">
              <label for="input"> ${this.label} </label>
            </gds-text>
            ${when(this.supportingText, () => __privateMethod(this, _renderSupportingText, renderSupportingText_fn).call(this))}
          </gds-flex>
          ${until(__privateMethod(this, _asyncRenderExtendedSupportingTextButton, asyncRenderExtendedSupportingTextButton_fn).call(this), nothing)}
        </gds-flex>

        ${__privateMethod(this, _renderExtendedSupportingText, renderExtendedSupportingText_fn).call(this)}

        <gds-flex
          position="relative"
          align-items="flex-start"
          justify-content="center"
          gap="xs"
          level="3"
          padding=${!this.trailSlotOccupied ? "s s s m" : "s m s m"}
          border-radius="xs"
          .background=${this.disabled ? "disabled" : this.invalid ? "negative-secondary" : "secondary"}
          .border=${this.disabled ? "" : this.invalid ? "4xs/negative" : "4xs/secondary"}
          class="field ${this.invalid ? "invalid" : ""}"
          @click=${__privateGet(this, _handleFieldClick)}
          cursor="text"
        >
          ${__privateMethod(this, _renderSlotLead, renderSlotLead_fn).call(this)} ${__privateMethod(this, _renderNativeTextarea, renderNativeTextarea_fn).call(this)}

          <gds-flex gap="xs" align-items="center" block-size="l">
            ${__privateMethod(this, _renderClearButton, renderClearButton_fn).call(this)} ${__privateMethod(this, _renderSlotTrail, renderSlotTrail_fn).call(this)}
          </gds-flex>
          ${when(
    this.resize === "auto",
    () => __privateMethod(this, _renderResizeHandle, renderResizeHandle_fn).call(this),
    () => nothing
  )}
        </gds-flex>

        <gds-flex
          class="foot"
          align-items="flex-start"
          justify-content="space-between"
          aria-live="polite"
          gap="xl"
        >
          ${when(
    this.invalid,
    () => html`
              <gds-flex align-items="flex-start" gap="xs" margin="2xs 0 0 0">
                <gds-flex min-width="18px">
                  <gds-icon-triangle-exclamation width="18" height="18" solid>
                  </gds-icon-triangle-exclamation>
                </gds-flex>
                <gds-text
                  tag="span"
                  font-size="detail-s"
                  font-weight="book"
                  class="error-text"
                >
                  ${this.validationMessage}
                </gds-text>
              </gds-flex>
            `
  )}
          <gds-flex
            margin="0 0 0 auto"
            min-width="4ch"
            justify-content="flex-end"
          >
            ${when(
    __privateGet(this, _shouldShowRemainingChars, shouldShowRemainingChars_get),
    () => __privateMethod(this, _renderRemainingCharsBadge, renderRemainingCharsBadge_fn).call(this)
  )}
          </gds-flex>
        </gds-flex>
      </gds-flex>
    `;
};
_renderFloatingLabel = new WeakSet();
renderFloatingLabel_fn = function() {
  return nothing;
};
_forwardableAttrs = new WeakMap();
_handleOnInput = new WeakMap();
_handleOnChange = new WeakMap();
_handleFieldClick = new WeakMap();
_handleClearBtnClick = new WeakMap();
_handleSupportingTextBtnClick = new WeakMap();
_renderSlotLead = new WeakSet();
renderSlotLead_fn = function() {
  return html` <slot name="lead"></slot> `;
};
_renderSlotTrail = new WeakSet();
renderSlotTrail_fn = function() {
  return html`
      <slot name="trail" @slotchange=${__privateMethod(this, _handleSlotChange, handleSlotChange_fn)}></slot>
    `;
};
_addResizeHandleListener = new WeakSet();
addResizeHandleListener_fn = function() {
  const resizeHandle = this.querySelector(".resize-handle");
  if (resizeHandle) {
    resizeHandle.addEventListener(
      "mousedown",
      __privateMethod(this, _startDragging, startDragging_fn).bind(this)
    );
  }
};
_startDragging = new WeakSet();
startDragging_fn = function(event) {
  event.preventDefault();
  this.isDragging = true;
  this.lastMouseY = event.clientY;
  document.addEventListener("mousemove", __privateMethod(this, _onDrag, onDrag_fn).bind(this));
  document.addEventListener("mouseup", __privateMethod(this, _stopDragging, stopDragging_fn).bind(this));
};
_onDrag = new WeakSet();
onDrag_fn = function(event) {
  if (!this.isDragging)
    return;
  const deltaY = event.clientY - this.lastMouseY;
  if (Math.abs(deltaY) >= 20) {
    if (deltaY > 0) {
      this.lines += 1;
    } else {
      this.lines = Math.max(1, this.lines - 1);
    }
    this.elTextareaAsync.then((element) => {
      element == null ? void 0 : element.style.setProperty("--_lines", this.lines.toString());
    });
    this.lastMouseY = event.clientY;
  }
};
_stopDragging = new WeakSet();
stopDragging_fn = function() {
  this.isDragging = false;
  document.removeEventListener("mousemove", __privateMethod(this, _onDrag, onDrag_fn).bind(this));
  document.removeEventListener("mouseup", __privateMethod(this, _stopDragging, stopDragging_fn).bind(this));
};
_renderResizeHandle = new WeakSet();
renderResizeHandle_fn = function() {
  return html`
      <gds-container
        class="resize-handle"
        position="absolute"
        inset="auto auto -10px 0"
        width="100%"
        height="20px"
        cursor="row-resize"
        z-index="2"
        @mousedown=${__privateMethod(this, _startDragging, startDragging_fn)}
      ></gds-container>
    `;
};
_handleSlotChange = new WeakSet();
handleSlotChange_fn = function(event) {
  const slot = event.target;
  const assignedNodes = slot.assignedNodes({ flatten: true });
  this.trailSlotOccupied = assignedNodes.length > 0 && assignedNodes.some(
    (node) => {
      var _a;
      return node.nodeType === Node.ELEMENT_NODE || node.nodeType === Node.TEXT_NODE && ((_a = node.textContent) == null ? void 0 : _a.trim()) !== "";
    }
  );
};
_renderNativeTextarea = new WeakSet();
renderNativeTextarea_fn = function() {
  return html`
      <textarea
        @input=${__privateGet(this, _handleOnInput)}
        @change=${__privateGet(this, _handleOnChange)}
        .value=${this.value}
        id="input"
        style="${this.invalid ? "color: var(--gds-color-l3-content-negative);" : this.disabled ? "color: currentColor;pointer-events:none;" : null}"
        aria-describedby="supporting-text"
        placeholder=" "
        ${forwardAttributes(__privateGet(this, _forwardableAttrs))}
      ></textarea>
    `;
};
_renderSupportingText = new WeakSet();
renderSupportingText_fn = function() {
  return html`
      <gds-text
        level="3"
        font-size="detail-m"
        .color="${this.disabled ? "disabled" : this.invalid ? "negative" : "tertiary"}"
        class="supporting-text"
        id="supporting-text"
      >
        ${this.supportingText}
      </gds-text>
    `;
};
_renderExtendedSupportingText = new WeakSet();
renderExtendedSupportingText_fn = function() {
  return html`
      <gds-card
        level="3"
        display="${this.showExtendedSupportingText ? "block" : "none"}"
        class="extended-supporting-text"
        padding="s m"
        border-radius="xs"
        background="secondary"
        color="tertiary"
      >
        <gds-text
          font-size="body-s"
          display="${this.showExtendedSupportingText ? "block" : "none"}"
        >
          <slot
            name="extended-supporting-text"
            @slotchange=${() => this.requestUpdate()}
          ></slot>
        </gds-text>
      </gds-card>
    `;
};
_renderClearButton = new WeakSet();
renderClearButton_fn = function() {
  if (this.clearable && this.value.length > 0)
    return html`
        <gds-button
          size="small"
          rank="tertiary"
          variant="${this.invalid ? "negative" : ""}"
          ?disabled="${this.disabled}"
          label="${msg("Clear input")}"
          @click=${__privateGet(this, _handleClearBtnClick)}
        >
          <gds-icon-cross-small />
        </gds-button>
      `;
  else
    return nothing;
};
_shouldShowRemainingChars = new WeakSet();
shouldShowRemainingChars_get = function() {
  return this.maxlength < Number.MAX_SAFE_INTEGER;
};
_renderRemainingCharsBadge = new WeakSet();
renderRemainingCharsBadge_fn = function() {
  const remaining = this.maxlength - this.value.length;
  let variant;
  if (remaining < 0) {
    variant = "negative";
  } else if (remaining < 20) {
    variant = "warning";
  } else {
    variant = "positive";
  }
  return html`<gds-badge variant="${variant}">${remaining}</gds-badge>`;
};
_asyncRenderExtendedSupportingTextButton = new WeakSet();
asyncRenderExtendedSupportingTextButton_fn = async function() {
  return this.elExtendedSupportingTextSlot.then((slot) => {
    if (slot && slot.assignedElements().length > 0)
      return html`
          <gds-button
            size="small"
            rank="tertiary"
            label="${msg("Show extended supporting text")}"
            @click=${__privateGet(this, _handleSupportingTextBtnClick)}
          >
            <gds-icon-circle-info ?solid=${this.showExtendedSupportingText} />
          </gds-button>
        `;
    else
      return nothing;
  });
};
GdsTextarea.styles = [tokens, styles];
__decorateClass([
  property()
], GdsTextarea.prototype, "value", 2);
__decorateClass([
  property()
], GdsTextarea.prototype, "label", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v,
    selector: "textarea",
    styleTemplate: (_prop, values) => {
      const ROWS = values[0];
      return `min-height: calc(1lh * ${ROWS});`;
    }
  })
], GdsTextarea.prototype, "rows", 2);
__decorateClass([
  state()
], GdsTextarea.prototype, "lines", 2);
__decorateClass([
  property({ attribute: "supporting-text" })
], GdsTextarea.prototype, "supportingText", 2);
__decorateClass([
  property({
    attribute: "show-extended-supporting-text",
    type: Boolean,
    reflect: true
  })
], GdsTextarea.prototype, "showExtendedSupportingText", 2);
__decorateClass([
  property({
    attribute: "disabled",
    type: Boolean,
    reflect: true
  })
], GdsTextarea.prototype, "disabled", 2);
__decorateClass([
  property({ type: Boolean })
], GdsTextarea.prototype, "clearable", 2);
__decorateClass([
  property()
], GdsTextarea.prototype, "resize", 2);
__decorateClass([
  property({ type: Number })
], GdsTextarea.prototype, "maxlength", 2);
__decorateClass([
  property({ type: String })
], GdsTextarea.prototype, "variant", 2);
__decorateClass([
  queryAsync("textarea")
], GdsTextarea.prototype, "elTextareaAsync", 2);
__decorateClass([
  query("textarea")
], GdsTextarea.prototype, "elTextarea", 2);
__decorateClass([
  queryAsync('slot[name="extended-supporting-text"]')
], GdsTextarea.prototype, "elExtendedSupportingTextSlot", 2);
__decorateClass([
  state()
], GdsTextarea.prototype, "trailSlotOccupied", 2);
__decorateClass([
  watch("value")
], GdsTextarea.prototype, "_setAutoHeight", 1);
GdsTextarea = __decorateClass([
  gdsCustomElement("gds-textarea")
], GdsTextarea);

export {
  GdsTextarea
};
