import {
  styleExpressionProperty
} from "./chunk.6UWYSL2J.js";
import {
  tokens
} from "./chunk.G4YDI5AG.js";
import {
  GdsElement
} from "./chunk.WIZDAKJ5.js";
import {
  gdsCustomElement,
  html
} from "./chunk.MLXMQIEV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/layout/container/container.ts
import { property } from "lit/decorators.js";

// libs/core/src/components/layout/container/container.style.ts
import { css } from "lit";
var style = css`
  :host {
    box-sizing: border-box;
  }
`;
var container_style_default = style;

// libs/core/src/components/layout/container/container.ts
var GdsContainer = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.display = "block";
    this.level = "2";
  }
  render() {
    return html`<slot></slot>`;
  }
};
GdsContainer.styles = [tokens, container_style_default];
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "display", 2);
__decorateClass([
  property()
], GdsContainer.prototype, "level", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "place-items", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "place-content", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: function(v) {
      const [colorInput, transparency] = v.split("/");
      const isCustomColor = (color) => {
        const trimmedColor = color.trim();
        return trimmedColor.startsWith("#") || // Hex color
        trimmedColor.startsWith("rgb(") || // RGB color
        trimmedColor.startsWith("rgba(") || // RGBA color
        trimmedColor.startsWith("hsl(") || // HSL color
        trimmedColor.startsWith("hsla(");
      };
      const constructCssVariable = (level, colorName) => {
        return `var(--gds-color-l${level}-content-${colorName})`;
      };
      const getColorValue = (color, transparency2) => {
        if (isCustomColor(color)) {
          return transparency2 ? `color-mix(in srgb, ${color} ${parseFloat(transparency2) * 100}%, transparent 0%)` : color;
        } else {
          return constructCssVariable(this.level, color);
        }
      };
      return getColorValue(colorInput, transparency);
    }
  })
], GdsContainer.prototype, "color", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: function(v) {
      const [colorInput, transparency] = v.split("/");
      const isCustomColor = (color) => {
        const trimmedColor = color.trim();
        return trimmedColor.startsWith("#") || // Hex color
        trimmedColor.startsWith("rgb(") || // RGB color
        trimmedColor.startsWith("rgba(") || // RGBA color
        trimmedColor.startsWith("hsl(") || // HSL color
        trimmedColor.startsWith("hsla(");
      };
      const constructCssVariable = (level, color) => {
        return `var(--gds-color-l${level}-background-${color})`;
      };
      const getBackgroundColor = (color, transparency2) => {
        if (isCustomColor(color)) {
          return transparency2 ? `color-mix(in srgb, ${color} ${parseFloat(transparency2) * 100}%, transparent 0%)` : color;
        } else {
          return constructCssVariable(this.level, color);
        }
      };
      return getBackgroundColor(colorInput, transparency);
    }
  })
], GdsContainer.prototype, "background", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: function(v) {
      const [size, color] = v.split("/");
      const isCustomColor = (color2) => {
        const trimmedColor = color2.trim();
        return trimmedColor.startsWith("#") || // Hex color
        trimmedColor.startsWith("rgb(") || // RGB color
        trimmedColor.startsWith("rgba(") || // RGBA color
        trimmedColor.startsWith("hsl(") || // HSL color
        trimmedColor.startsWith("hsla(");
      };
      const constructBorderColorVariable = (level, color2) => {
        return `var(--gds-color-l${level}-border-${color2})`;
      };
      const getBorderColorValue = (color2) => {
        return isCustomColor(color2) ? color2 : constructBorderColorVariable(this.level, color2);
      };
      return `var(--gds-space-${size}) solid ${color ? getBorderColorValue(color) : "currentColor"}`;
    },
    styleTemplate: (_prop, values) => {
      const top = values[0];
      const right = values.length > 1 ? values[1] : top;
      const bottom = values.length > 2 ? values[2] : top;
      const left = values.length > 3 ? values[3] : top;
      return `
        border-top: ${top}; 
        border-right: ${right}; 
        border-bottom: ${bottom}; 
        border-left: ${left};
      `;
    }
  })
], GdsContainer.prototype, "border", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: function(v) {
      const [color] = v.split("/");
      const isCustomColor = (color2) => {
        const trimmedColor = color2.trim();
        return trimmedColor.startsWith("#") || // Hex color
        trimmedColor.startsWith("rgb(") || // RGB color
        trimmedColor.startsWith("rgba(") || // RGBA color
        trimmedColor.startsWith("hsl(") || // HSL color
        trimmedColor.startsWith("hsla(");
      };
      const constructBorderColorVariable = (level, color2) => {
        return `var(--gds-color-l${level}-border-${color2})`;
      };
      const getBorderColorValue = (color2) => {
        return isCustomColor(color2) ? color2 : constructBorderColorVariable(this.level, color2);
      };
      return color ? getBorderColorValue(color) : "currentColor";
    },
    styleTemplate: (_prop, values) => {
      const top = values[0];
      const right = values.length > 1 ? values[1] : top;
      const bottom = values.length > 2 ? values[2] : top;
      const left = values.length > 3 ? values[3] : top;
      return `
        border-top-color: ${top}; 
        border-right-color: ${right}; 
        border-bottom-color: ${bottom}; 
        border-left-color: ${left};
      `;
    }
  })
], GdsContainer.prototype, "border-color", 2);
__decorateClass([
  styleExpressionProperty({
    styleTemplate: (_prop, values) => {
      const top = values[0];
      const right = values.length > 1 ? values[1] : top;
      const bottom = values.length > 2 ? values[2] : top;
      const left = values.length > 3 ? values[3] : top;
      return `
        border-top-width: ${top}; 
        border-right-width: ${right}; 
        border-bottom-width: ${bottom}; 
        border-left-width: ${left};
        border-style: solid;
      `;
    }
  })
], GdsContainer.prototype, "border-width", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `var(--gds-space-${v})`
  })
], GdsContainer.prototype, "border-radius", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "opacity", 2);
__decorateClass([
  styleExpressionProperty()
], GdsContainer.prototype, "padding", 2);
__decorateClass([
  styleExpressionProperty()
], GdsContainer.prototype, "padding-inline", 2);
__decorateClass([
  styleExpressionProperty()
], GdsContainer.prototype, "padding-block", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => {
      return v === "auto" ? "auto" : `var(--gds-space-${v})`;
    },
    styleTemplate: (_prop, values) => {
      const transformValue = (v) => v === "auto" ? "auto" : `${v}`;
      const top = transformValue(values[0]);
      const right = values.length > 1 ? transformValue(values[1]) : top;
      const bottom = values.length > 2 ? transformValue(values[2]) : top;
      const left = values.length > 3 ? transformValue(values[3]) : right;
      return `margin: ${top} ${right} ${bottom} ${left};`;
    }
  })
], GdsContainer.prototype, "margin", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "position", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "inset", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "overflow", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `${v}`
  })
], GdsContainer.prototype, "grid-column", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `${v}`
  })
], GdsContainer.prototype, "grid-row", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "height", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "max-height", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "min-height", 2);
__decorateClass([
  styleExpressionProperty()
], GdsContainer.prototype, "block-size", 2);
__decorateClass([
  styleExpressionProperty()
], GdsContainer.prototype, "min-block-size", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "width", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "max-width", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "min-width", 2);
__decorateClass([
  styleExpressionProperty()
], GdsContainer.prototype, "inline-size", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "cursor", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "pointer-events", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "user-select", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "z-index", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "transform", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "transform-style", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "transition", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "transition-behavior", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsContainer.prototype, "animation", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `${v}`,
    styleTemplate: (prop, values) => {
      const size = values[0];
      const styleSize = `font-size: var(--gds-text-size-${size});`;
      const styleLine = `line-height: var(--gds-text-line-height-${size});`;
      return styleSize + styleLine;
    }
  })
], GdsContainer.prototype, "font-size", 2);
__decorateClass([
  styleExpressionProperty({
    property: "font-weight",
    valueTemplate: (v) => `var(--gds-text-weight-${v})`
  })
], GdsContainer.prototype, "font-weight", 2);
GdsContainer = __decorateClass([
  gdsCustomElement("gds-container")
], GdsContainer);

export {
  GdsContainer
};
