// libs/core/src/utils/helpers/attribute-converters.ts
var dateConverter = {
  fromAttribute(value) {
    return new Date(value);
  },
  toAttribute(value) {
    return value.toISOString();
  }
};
var dateArrayConverter = {
  fromAttribute(value) {
    return value.split(",").map((d) => new Date(d.trim()));
  },
  toAttribute(value) {
    return JSON.stringify(value.map((d) => d.toISOString()));
  }
};
var stringArrayConverter = {
  fromAttribute(value) {
    return value.split(",");
  },
  toAttribute(value) {
    return Array.isArray(value) ? value.join(",") : value;
  }
};

export {
  dateConverter,
  dateArrayConverter,
  stringArrayConverter
};
