import {
  TransitionalStyles
} from "./chunk.TQCUATGL.js";
import {
  watch
} from "./chunk.TYGMNHNO.js";
import {
  dark_default,
  light_default
} from "./chunk.G4YDI5AG.js";
import {
  GdsElement
} from "./chunk.WIZDAKJ5.js";
import {
  gdsCustomElement,
  html
} from "./chunk.MLXMQIEV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/theme/theme.ts
import { property } from "lit/decorators.js";
import { css, unsafeCSS } from "lit";
var GdsTheme = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.colorScheme = "light";
  }
  connectedCallback() {
    super.connectedCallback();
    TransitionalStyles.instance.apply(this, "gds-theme");
    this._dynamicStylesController.inject(
      "dark",
      unsafeCSS(`:host {${dark_default}}`)
    );
  }
  render() {
    return html`<slot></slot>`;
  }
  _onColorSchemeChange() {
    if (this.colorScheme === "dark") {
      this._dynamicStylesController.inject(
        "dark",
        unsafeCSS(`:host { ${dark_default}}`)
      );
    } else {
      this._dynamicStylesController.inject(
        "light",
        unsafeCSS(`:host { ${light_default}}`)
      );
    }
  }
};
GdsTheme.styles = css`
    :host {
      display: contents;
    }
  `;
__decorateClass([
  property({ reflect: true, attribute: "color-scheme" })
], GdsTheme.prototype, "colorScheme", 2);
__decorateClass([
  watch("colorScheme")
], GdsTheme.prototype, "_onColorSchemeChange", 1);
GdsTheme = __decorateClass([
  gdsCustomElement("gds-theme")
], GdsTheme);

export {
  GdsTheme
};
