import {
  styleExpressionProperty
} from "./chunk.6UWYSL2J.js";
import {
  tokens
} from "./chunk.G4YDI5AG.js";
import {
  GdsElement
} from "./chunk.WIZDAKJ5.js";
import {
  gdsCustomElement,
  html
} from "./chunk.MLXMQIEV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/content/divider/divider.style.ts
import { css } from "lit";
var style = css`
  :host {
    display: block;
    border-radius: 200px;
    background: currentColor;
    font-size: 0;
    border: 0;
    height: 1px;
    width: 100%;
    margin-top: calc((var(--_size, 0) / 2) - (1px / 2));
    margin-bottom: calc((var(--_size, 0) / 2) - (1px / 2));
  }
`;
var divider_style_default = style;

// libs/core/src/components/content/divider/divider.ts
var GdsDivider = class extends GdsElement {
  render() {
    return html``;
  }
};
GdsDivider.styles = [tokens, divider_style_default];
__decorateClass([
  styleExpressionProperty({
    property: "color",
    valueTemplate: (v) => {
      const [colorName, transparency] = v.split("/");
      if (transparency) {
        return `color-mix(in srgb, var(--gds-sys-color-${colorName}) ${parseFloat(transparency) * 100}%, transparent 0%)`;
      } else {
        return `var(--gds-sys-color-${colorName})`;
      }
    }
  })
], GdsDivider.prototype, "color", 2);
__decorateClass([
  styleExpressionProperty({
    property: "--_size",
    valueTemplate: (v) => `var(--gds-space-${v})`
  })
], GdsDivider.prototype, "size", 2);
__decorateClass([
  styleExpressionProperty({
    property: "opacity",
    valueTemplate: (v) => v
  })
], GdsDivider.prototype, "opacity", 2);
GdsDivider = __decorateClass([
  gdsCustomElement("gds-divider")
], GdsDivider);

export {
  GdsDivider
};
