import {
  resizeObserver
} from "./chunk.VHN4JEZC.js";
import {
  stringArrayConverter
} from "./chunk.C3ECHGX7.js";
import {
  GdsFormControlElement
} from "./chunk.X7GD7UEM.js";
import {
  watch
} from "./chunk.TYGMNHNO.js";
import {
  gdsCustomElement,
  html
} from "./chunk.MLXMQIEV.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet,
  __privateMethod,
  __privateSet
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/filter-chips/filter-chips.ts
import { property, query, state } from "lit/decorators.js";
import { classMap } from "lit/directives/class-map.js";

// libs/core/src/components/filter-chips/filter-chips.styles.ts
import { css } from "lit";
var styles = css`
  @layer base, reset, transitional-styles;
  @layer base {
    :host {
      display: inline-block;
      max-width: 100%;
    }

    .chips {
      display: flex;
      flex-wrap: wrap;
      gap: 0.5rem;
    }

    .collapse {
      overflow: auto;
      scroll-snap-type: both mandatory;
      overscroll-behavior-x: contain;
      flex-wrap: nowrap;
      padding-bottom: 0.5rem;
      scrollbar-color: rgba(0, 0, 0, 0.5) transparent;
      scrollbar-width: thin;
    }

    ::slotted(*) {
      scroll-snap-align: start;
      scroll-snap-stop: always;
    }
  }
`;

// libs/core/src/components/filter-chips/filter-chips.ts
var _handleChipClick, _collapseThreshold, _collapsedAt, _getChipHeight, getChipHeight_fn, _handleSlotChange, handleSlotChange_fn;
var GdsFilterChips = class extends GdsFormControlElement {
  constructor() {
    super(...arguments);
    __privateAdd(this, _getChipHeight);
    __privateAdd(this, _handleSlotChange);
    this.multiple = false;
    this.label = "";
    this.rowCollapse = false;
    this._collapsed = false;
    __privateAdd(this, _handleChipClick, (event) => {
      const clickedChip = this.chips.find(
        (s) => s === event.target || s.contains(event.target)
      );
      if (clickedChip) {
        if (this.multiple && Array.isArray(this.value)) {
          if (clickedChip.selected) {
            this.value = this.value.filter((v) => v !== clickedChip.value);
          } else {
            this.value = [...this.value, clickedChip.value];
          }
        } else {
          this.value = clickedChip.value;
        }
        this.dispatchEvent(
          new CustomEvent("change", {
            detail: { clickedChip, value: this.value },
            bubbles: true,
            composed: true
          })
        );
      }
    });
    __privateAdd(this, _collapseThreshold, 3);
    __privateAdd(this, _collapsedAt, 0);
  }
  /**
   * Returns the chips in the control
   * @readonly
   */
  get chips() {
    return this._elSlot ? this._elSlot.assignedElements() : [];
  }
  render() {
    const layoutClasses = {
      collapse: this._collapsed
    };
    return html`<div
      class="chips ${classMap(layoutClasses)}"
      role="listbox"
      aria-label=${this.label}
      aria-multiselectable=${this.multiple}
    >
      <slot
        @click=${__privateGet(this, _handleChipClick)}
        @slotchange=${__privateMethod(this, _handleSlotChange, handleSlotChange_fn)}
        role="none"
      ></slot>
    </div>`;
  }
  _getValidityAnchor() {
    return this;
  }
  _handleResize() {
    if (!this.rowCollapse)
      return;
    const chipHeight = __privateMethod(this, _getChipHeight, getChipHeight_fn).call(this);
    const selfHeight = this.offsetHeight;
    const selfWidth = this.offsetWidth;
    if (selfHeight >= chipHeight * __privateGet(this, _collapseThreshold)) {
      this._collapsed = true;
      __privateSet(this, _collapsedAt, selfWidth);
    }
    if (selfWidth > __privateGet(this, _collapsedAt)) {
      this._collapsed = false;
    }
  }
  _updateSelectedFromValue() {
    if (!this.value)
      return;
    if (this.multiple && !Array.isArray(this.value)) {
      this.value = [this.value];
    }
    if (!this.multiple && Array.isArray(this.value)) {
      this.value = this.value[0];
    }
    this.updateComplete.then(() => {
      this.chips.forEach((chip) => {
        chip.selected = this.multiple ? this.value.includes(chip.value) : this.value === chip.value;
      });
    });
  }
};
_handleChipClick = new WeakMap();
_collapseThreshold = new WeakMap();
_collapsedAt = new WeakMap();
_getChipHeight = new WeakSet();
getChipHeight_fn = function() {
  var _a;
  return ((_a = this.chips[0]) == null ? void 0 : _a.offsetHeight) || 0;
};
_handleSlotChange = new WeakSet();
handleSlotChange_fn = function() {
  var _a;
  const selChipValue = (_a = this.chips.find((s) => s.selected)) == null ? void 0 : _a.value;
  if (selChipValue) {
    this.value = selChipValue;
  }
};
GdsFilterChips.styles = [styles];
__decorateClass([
  property({ converter: stringArrayConverter })
], GdsFilterChips.prototype, "value", 2);
__decorateClass([
  property({ type: Boolean })
], GdsFilterChips.prototype, "multiple", 2);
__decorateClass([
  property()
], GdsFilterChips.prototype, "label", 2);
__decorateClass([
  property({ type: Boolean, attribute: "row-collapse" })
], GdsFilterChips.prototype, "rowCollapse", 2);
__decorateClass([
  state()
], GdsFilterChips.prototype, "_collapsed", 2);
__decorateClass([
  query("slot")
], GdsFilterChips.prototype, "_elSlot", 2);
__decorateClass([
  resizeObserver()
], GdsFilterChips.prototype, "_handleResize", 1);
__decorateClass([
  watch("value")
], GdsFilterChips.prototype, "_updateSelectedFromValue", 1);
GdsFilterChips = __decorateClass([
  gdsCustomElement("gds-filter-chips")
], GdsFilterChips);

export {
  GdsFilterChips
};
