import {
  styleExpressionProperty
} from "./chunk.6UWYSL2J.js";
import {
  TransitionalStyles
} from "./chunk.TQCUATGL.js";
import {
  tokens
} from "./chunk.G4YDI5AG.js";
import {
  GdsElement
} from "./chunk.WIZDAKJ5.js";
import {
  gdsCustomElement,
  html
} from "./chunk.MLXMQIEV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/segmented-control/segment/segment.ts
import { property } from "lit/decorators.js";
import { unsafeCSS } from "lit";

// libs/core/src/components/segmented-control/segment/segment.style.css?inline
var segment_style_default = `:host {
  display: flex;
  z-index: 1;
}

button {
  -webkit-appearance: none;
     -moz-appearance: none;
          appearance: none;
  background: transparent;
  border-radius: calc(infinity * 1px);
  border-width: 0;
  color: var(--gds-sys-color-content-content);
  cursor: pointer;
  flex-grow: 1;
  flex-shrink: 0;
  font-family: inherit;
  font-size: inherit;
  overflow: hidden;
  padding: 0 1rem;
  text-align: center;
  text-overflow: ellipsis;
  white-space: nowrap;
  width: 100%;
  transition: 0.1s;

  &:disabled {
    cursor: not-allowed;
    opacity: 0.5;
  }
}

@media (pointer: fine) {
  :host(:not([selected])) button:hover {
    background-color: color-mix(
      in srgb,
      var(--gds-sys-color-state-layers-state-black-dim1),
      transparent
    );

    &:disabled {
      background-color: transparent;
    }
  }
}

button:focus-visible {
  outline: 2px solid #000;
  outline-offset: -2px;
}
`;

// libs/core/src/components/segmented-control/segment/segment.ts
var GdsSegment = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.selected = false;
    this.disabled = false;
    // This is deliberatly not marked as private, since we're setting it from the parent component,
    // but it is not meant to be set by the consumer.
    this._isVisible = true;
  }
  /**
   * Whether the segment is currently visible.
   */
  get isVisible() {
    return this._isVisible;
  }
  connectedCallback() {
    super.connectedCallback();
    TransitionalStyles.instance.apply(this, "gds-segmented");
    this.setAttribute("role", "listitem");
  }
  render() {
    return html`<button
      aria-current=${String(this.selected)}
      ?disabled="${this.disabled}"
    >
      <slot></slot>
    </button>`;
  }
};
GdsSegment.styles = [...tokens, unsafeCSS(segment_style_default)];
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsSegment.prototype, "selected", 2);
__decorateClass([
  property()
], GdsSegment.prototype, "value", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsSegment.prototype, "disabled", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsSegment.prototype, "min-width", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v
  })
], GdsSegment.prototype, "max-width", 2);
__decorateClass([
  styleExpressionProperty()
], GdsSegment.prototype, "width", 2);
GdsSegment = __decorateClass([
  gdsCustomElement("gds-segment")
], GdsSegment);

export {
  GdsSegment
};
