import {
  GdsElement
} from "./chunk.WIZDAKJ5.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/icon/icon.ts
import { html } from "lit";
import { property } from "lit/decorators.js";
import { unsafeHTML } from "lit/directives/unsafe-html.js";

// libs/core/src/components/icon/icon.style.ts
import { css } from "lit";
var style = css`
  @layer icon;

  @layer icon {
    :host {
      display: inline-block;
    }

    svg {
      display: block;
    }
  }
`;
var icon_style_default = style;

// libs/core/src/components/icon/icon.ts
var GdsIcon = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.solid = false;
    this.box = false;
    this.label = "";
  }
  render() {
    const isSebIcon = this.constructor._name === "brand-seb";
    const width = isSebIcon ? "55" : this.width !== void 0 ? this.width.toString() : void 0;
    const height = isSebIcon ? "24" : this.height !== void 0 ? this.height.toString() : "1lh";
    const viewBox = isSebIcon ? "0 0 55 24" : this.box || "0 0 24 24";
    let svgContent = `<svg
      ${width ? `width="${width}"` : ""}
      height="${height}"
      viewBox="${viewBox}"
      fill="none"
      xmlns="http://www.w3.org/2000/svg"
      ${this.label ? `aria-label="${this.label}"` : `aria-label="${this.constructor._name}"`}
      role="graphics-symbol"
      part="icon" 
    >
      ${this.solid ? this.constructor._solidSVG : this.constructor._regularSVG}
    </svg>`;
    if (this.stroke) {
      svgContent = svgContent.replace(
        /<(path|rect|circle|ellipse|line|polyline|polygon)/g,
        `<$1 stroke-width="${this.stroke}"`
      );
    }
    return html`${unsafeHTML(svgContent)}`;
  }
};
GdsIcon.styles = [icon_style_default];
__decorateClass([
  property({ type: Number })
], GdsIcon.prototype, "width", 2);
__decorateClass([
  property({ type: Number })
], GdsIcon.prototype, "height", 2);
__decorateClass([
  property({ type: Boolean })
], GdsIcon.prototype, "solid", 2);
__decorateClass([
  property({ type: Number })
], GdsIcon.prototype, "stroke", 2);
__decorateClass([
  property({ type: String })
], GdsIcon.prototype, "box", 2);
__decorateClass([
  property({ type: String })
], GdsIcon.prototype, "label", 2);

export {
  GdsIcon
};
