import { GdsButton } from '../button';
/**
 * @element gds-fab
 *
 * The Floating Action Button is used for functions central to the user experience, such as
 * support and help features that needs to be accessible at all times.
 *
 * The button is always floating visible in the users viewport, typically in the lower right
 * corner. This button can be used with an icon only.
 *
 * @slot - Content of the FAB
 */
export declare class GdsFab extends GdsButton {
    /**
     * Supports all valid CSS position values.
     */
    position?: string;
    /**
     * The transform of the FAB. Use this to tweak the position of the element on the screen.
     *
     * Accepts any valid CSS transform value.
     */
    transform?: string;
    /**
     * The inset postion of the FAB.
     *
     * Accepts any valid CSS inset values.
     */
    inset?: string;
    connectedCallback(): void;
}
